import { jsx as c, jsxs as E, Fragment as T } from "react/jsx-runtime";
import I from "clsx";
import * as i from "react";
import { useRef as _, useReducer as M, useEffect as D, useId as A } from "react";
import { useFloating as x, useClick as S, useDismiss as P, useRole as $, useInteractions as F, useMergeRefs as O, FloatingPortal as k, FloatingOverlay as L, FloatingFocusManager as U } from "@floating-ui/react";
const w = "SET_ANNOUNCEMENT", C = "CLEAR_ANNOUNCEMENT", V = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, B = (e, n) => {
  switch (n == null ? void 0 : n.type) {
    case w:
      return {
        ...e,
        announcement: n.payload
      };
    case C:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, j = ({
  onAnnouncementClear: e,
  dispatch: n
}) => {
  n({
    type: C
  }), typeof e == "function" && e();
}, b = ({
  children: e,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: o,
  dispatch: l
}) => {
  clearTimeout(t.current), e !== null && l({
    type: w,
    payload: e
  }), n && (t.current = setTimeout(
    () => j({
      onAnnouncementClear: o,
      dispatch: l
    }),
    n
  ));
}, G = ({
  children: e,
  announcementTimeoutRef: n,
  announcementDelay: t,
  clearAnnouncementDelay: o,
  clearAnnouncementTimeoutRef: l,
  onAnnouncementClear: r,
  dispatch: a
}) => {
  clearTimeout(n.current), t ? n.current = setTimeout(b, t, {
    children: e,
    clearAnnouncementDelay: o,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: r,
    dispatch: a
  }) : b({
    children: e,
    clearAnnouncementDelay: o,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: r,
    dispatch: a
  });
};
function W({
  children: e,
  className: n,
  politeness: t,
  role: o = null,
  announcementDelay: l,
  clearAnnouncementDelay: r,
  onAnnouncementClear: a,
  visible: s,
  ...p
}) {
  const u = _(null), d = _(null), [m, f] = M(B, {
    announcement: null
  });
  let h = t;
  typeof h > "u" && (h = o ? V[o] : "assertive"), D(() => {
    G({
      announcementTimeoutRef: u,
      announcementDelay: l,
      children: e,
      clearAnnouncementDelay: r,
      clearAnnouncementTimeoutRef: d,
      onAnnouncementClear: a,
      dispatch: f
    });
  }, [
    e,
    l,
    r,
    a
  ]);
  const g = I(n, {
    "sr-only": !s
  });
  return /* @__PURE__ */ c(
    "div",
    {
      "aria-live": h,
      ...o && { role: o },
      className: g,
      ...p,
      children: m.announcement
    }
  );
}
const N = i.createContext(null);
function q({
  initialOpen: e = !1,
  open: n,
  onOpenChange: t
} = {}) {
  const [o, l] = i.useState(e), [r, a] = i.useState(), [s, p] = i.useState(), u = n ?? o, d = t ?? l, m = x({
    open: u,
    onOpenChange: d
  }), f = m.context, h = S(f, {
    enabled: n == null
  }), g = P(f, {
    outsidePress: !1,
    outsidePressEvent: "mousedown"
  }), R = $(f), y = F([h, g, R]);
  return i.useMemo(
    () => ({
      open: u,
      setOpen: d,
      ...y,
      ...m,
      labelId: r,
      descriptionId: s,
      setLabelId: a,
      setDescriptionId: p
    }),
    [u, d, y, m, r, s]
  );
}
const v = () => {
  const e = i.useContext(N);
  if (e == null)
    throw new Error("Modal components must be wrapped in <Modal />");
  return e;
};
function X({
  children: e,
  ...n
}) {
  const t = q(n);
  return /* @__PURE__ */ c(N.Provider, { value: t, children: e });
}
const Y = i.forwardRef(function(e, n) {
  const { context: t, ...o } = v(), l = O([o.refs.setFloating, n]);
  if (!t.open)
    return null;
  const { overlayBackground: r, ...a } = e, s = I("grid place-items-center", {
    [`${r}`]: r,
    "bg-black sm:bg-black/[.8]": !r
  });
  return /* @__PURE__ */ c(k, { children: /* @__PURE__ */ c(L, { className: s, lockScroll: !0, children: /* @__PURE__ */ c(U, { context: t, children: /* @__PURE__ */ c(
    "div",
    {
      ref: l,
      "aria-labelledby": o.labelId,
      "aria-describedby": o.descriptionId,
      ...o.getFloatingProps(a),
      children: a.children
    }
  ) }) }) });
}), Z = i.forwardRef(function({ children: e, ...n }, t) {
  const { setLabelId: o } = v(), l = A();
  return i.useLayoutEffect(() => (o(l), () => o(void 0)), [l, o]), /* @__PURE__ */ c("h1", { ...n, ref: t, id: l, children: e });
}), ee = i.forwardRef(function({ children: e, ...n }, t) {
  const { setDescriptionId: o } = v(), l = A();
  return i.useLayoutEffect(() => (o(l), () => o(void 0)), [l, o]), /* @__PURE__ */ c("div", { ...n, ref: t, id: l, children: e });
}), ne = i.forwardRef(function(e, n) {
  const { setOpen: t } = v(), { trigger: o, className: l, ...r } = e, a = i.useCallback(() => t(!1), [t]);
  return /* @__PURE__ */ c("div", { className: l, children: i.cloneElement(o, {
    ref: n,
    onClick: a,
    ...r
  }) });
});
/*!
  @versini/ui-spacing v1.0.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_SPACING__ || (window.__VERSINI_UI_SPACING__ = {
    version: "1.0.0",
    buildTime: "12/24/2024 06:47 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const H = (e) => {
  let n = "";
  if (typeof e == "number" || typeof e == "string")
    n = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), n = t.join(" ");
  }
  return n;
}, te = ({
  children: e,
  fill: n,
  viewBox: t,
  className: o,
  defaultViewBox: l,
  defaultClassName: r,
  spacing: a,
  title: s,
  semantic: p = !1,
  ...u
}) => {
  const d = H(a), m = I(
    d,
    o || r
  );
  return /* @__PURE__ */ E(T, { children: [
    /* @__PURE__ */ c(
      "svg",
      {
        xmlns: "http://www.w3.org/2000/svg",
        className: m,
        viewBox: t || l,
        fill: n || "currentColor",
        role: "img",
        "aria-hidden": !p,
        focusable: !1,
        ...u,
        children: e
      }
    ),
    s && p && /* @__PURE__ */ c("span", { className: "sr-only", children: s })
  ] });
};
/*!
  @versini/ui-private v1.6.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.6.0",
    buildTime: "12/24/2024 06:47 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
export {
  W as LiveRegion,
  X as Modal,
  ne as ModalClose,
  Y as ModalContent,
  ee as ModalDescription,
  Z as ModalHeading,
  te as SvgIcon
};
